/*! \file****************************************************************************
*
* Atmel Corporation
*
* ̧       : main.c
* ߲     : IAR EWAAVR 2.28a/3.10c
* Rev.       : $Revision: 1.1 $
* t       : $Date: Wednesday, July 13, 2005 10:43:44 UTC $
* XV     : $Author: omella $
*
* xҰ    : avr@atmel.com
*
* x޲ : A/Dϊ킪gpłS޲BATmega16pɏĂ܂B
*
* pLq   : AVR121 - ߍ̎ɂA/Dϊ\
*
* e       : \̂߂̉ߍ̎gp@̗
*              {ނ10ޯĂ16ޯĂւA/Dϊ\@̗܂B
*              LSB݂̂ۏ؂邽߂ɁA̒PA/DϊʂUARTɏ̂
*              Lp܂B
*
***********************************************************************************/

#include <iom16.h>                    //!< ͯ ̧ ݸٰ
#include <inavr.h>                    //!< ͯ ̧ ݸٰ

// S̕ϐ
double        accumulator       = 0;  //!< 10ޯč̎ݐϒl
double        Vin               = 0;  //!< 16ޯĕ
short         temp              = 0;  //!< ꎞϐ
short         samples           = 0;  //!< ϊ񐔌vl

// ֐
void init_adc(void);
void init_counter(void);
void oversampled(void);

//! A/Dϊ荞ݏٰ
#pragma vector=ADC_vect
__interrupt void ADCinterrupt(void)
{
  accumulator += ADC;
  samples++;
}

/*! 64,AREF=VREF,ADC0ݸٴޘAϊ,El,A/Dϊ荞݋,ϊA/Dϊ평 */
void init_adc(void)
{
  ADCSRA = (1<<ADEN)|(1<<ADIE)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1);
  ADMUX = (0<<REFS1)|(0<<REFS0);                                 
  __enable_interrupt();
}

//! PWM,64ۯ,CTC,(OC2)50%ޭè/2
void init_counter(void)
{
  DDRD  = (1<<PD7);                    // PWMMpPD7o͐ݒ
  TCCR2 = (1<<WGM20)|(1<<WGM21)|(1<<COM21)|(1<<CS21);
  OCR2  = 128;
}

/*! 덷⏞,16ޯČʎړx␳,ۂ,16ޯČʌvZϐ */
void oversampled(void)
{
  __disable_interrupt();
  accumulator += 5150;                 // ̾Č덷⏞
  accumulator *= 0.9993;               // 덷⏞
  temp=(int)accumulator%64;
  accumulator/=64;                     // ړx␳
  if(temp>=32)
    {
      accumulator += 1;                // ۂ
    }
  Vin = (accumulator/65536)*4.910;     // 16ޯČʌvZ
  samples     = 0;
  accumulator = 0;
  __enable_interrupt();
}

void main( void )
{
  init_adc();                          // A/Dϊ평/Jn
  init_counter();                      // //Jn

  while(1)                             // JԂ
  {
    if(samples>4095)
      {
        oversampled();
      }
  }
}

